/*
 * Created on Dec 2, 2004
 *
 * Lecture class which contains the main method for examples done
 * in lectures for CS1020-001 Winter 2004-2005. 
 */
package cs1020;

import cs1020.TextFile;

/**
 * @author t a y l o r@msoe.edu
 *
 * Lecture class which contains the main method for examples done
 * in lectures for CS1020-001 Winter 2004-2005. 
 */
public class Lecture {

    /**
     * Example method for testing the TextFile class.  This version
     * displays the first test that fails or a message that all the
     * class passed all tests.
     * 
     * @author t a y l o r@msoe.edu
     * 
     * @param args Currently ignored
     */
    public static void main(String[] args) {
        TextFile t1 = new TextFile("text1.txt");
        TextFile t2 = new TextFile("text2.txt", "This is interesting");

        boolean noErrors = true;
        int num = 0;
        noErrors = noErrors && validate(t1.getFilename().equals("text1.txt"), ++num);
        noErrors = noErrors && validate(t1.getContents().equals(""), ++num);
        
        noErrors = noErrors && validate(t2.getFilename().equals("text2.txt"), ++num);
        noErrors = noErrors && validate(t2.getContents().equals("This is interesting"), ++num);
        
        t1.setContents("George eats oats");
        t2.setFilename("text3.txt");
        
        noErrors = noErrors && validate(t1.getFilename().equals("text1.txt"), ++num);
        noErrors = noErrors && validate(t1.getContents().equals("George eats oats"), ++num);
        
        noErrors = noErrors && validate(t2.getFilename().equals("text3.txt"), ++num);
        noErrors = noErrors && validate(t2.getContents().equals("This is interesting"), ++num);
        
        noErrors = noErrors && validate(!t1.equals(t2), ++num);

        t1.setContents(t2.getContents());
        t1.setFilename(t2.getFilename());

        noErrors = noErrors && validate(t1.equals(t2), ++num);

        t1.setContents("George eats oats");

        noErrors = noErrors && validate(!t1.equals(t2), ++num);
        
        t1 = t2;

        noErrors = noErrors && validate(t1.equals(t2), ++num);
        
        if(noErrors) {
            System.out.println("Passed all tests");
        }
    }

    /**
     * Displays an error message if the first parameter passed is
     * false.
     * 
     * @author t a y l o r@msoe.edu
     * 
     * @param isCorrect Indicates whether the test was valid or not.
     * @param num The test number which is displayed in the error message.
     */
    public static boolean validate(boolean isCorrect, int num) {
        if(!isCorrect) {
            System.out.println("Test #" + num + " failed!");
        }
        return isCorrect;
    }
    /**
     * Example method for testing the TextFile class.  This version
     * requires that the user individually check the program output
     * and verify that it is correct.
     * 
     * @author t a y l o r@msoe.edu
     * 
     * @param args Currently ignored
     */
    public static void main1(String[] args) {
        TextFile t1 = new TextFile("text1.txt");
        TextFile t2 = new TextFile("text2.txt", "This is interesting");
        
        System.out.println(t1.getFilename() + " " + t2.getFilename());
        System.out.println(t1.getContents() + " " + t2.getContents());
        
        t1.setContents("George eats oats");
        t2.setFilename("text3.txt");
        
        System.out.println(t1.getFilename() + " " + t2.getFilename());
        System.out.println(t1.getContents() + " " + t2.getContents());
        
        System.out.println(t1.equals(t2));
        
        t1.setContents(t2.getContents());
        t1.setFilename(t2.getFilename());
        
        System.out.println(t1.getFilename() + " " + t2.getFilename());
        System.out.println(t1.getContents() + " " + t2.getContents());
        
        System.out.println(t1.equals(t2));

        t1.setContents("George eats oats");
        
        System.out.println(t1.getFilename() + " " + t2.getFilename());
        System.out.println(t1.getContents() + " " + t2.getContents());
        
        System.out.println(t1.equals(t2));
        
        t1 = t2;
        
        System.out.println(t1.getFilename() + " " + t2.getFilename());
        System.out.println(t1.getContents() + " " + t2.getContents());
        
        System.out.println(t1.equals(t2));
    }
}